diff --git a/sysdeps/arm/nacl/libc.abilist b/sysdeps/arm/nacl/libc.abilist
index 4d22a7a..328d386 100644
--- a/sysdeps/arm/nacl/libc.abilist
+++ b/sysdeps/arm/nacl/libc.abilist
@@ -1855,5 +1855,11 @@ GLIBC_2.25 strfromf F
 GLIBC_2.25 strfroml F
 GLIBC_2.26 GLIBC_2.26 A
 GLIBC_2.26 __nl_langinfo_l F
+GLIBC_2.26 __strftime_l F
+GLIBC_2.26 __wcsftime_l F
 GLIBC_2.26 nl_langinfo F
 GLIBC_2.26 nl_langinfo_l F
+GLIBC_2.26 strftime F
+GLIBC_2.26 strftime_l F
+GLIBC_2.26 wcsftime F
+GLIBC_2.26 wcsftime_l F
diff --git a/sysdeps/unix/sysv/linux/aarch64/libc.abilist
b/sysdeps/unix/sysv/linux/aarch64/libc.abilist
index fc1cac5..7d753d6 100644
--- a/sysdeps/unix/sysv/linux/aarch64/libc.abilist
+++ b/sysdeps/unix/sysv/linux/aarch64/libc.abilist
@@ -2099,5 +2099,11 @@ GLIBC_2.25 strfromf F
 GLIBC_2.25 strfroml F
 GLIBC_2.26 GLIBC_2.26 A
 GLIBC_2.26 __nl_langinfo_l F
+GLIBC_2.26 __strftime_l F
+GLIBC_2.26 __wcsftime_l F
 GLIBC_2.26 nl_langinfo F
 GLIBC_2.26 nl_langinfo_l F
+GLIBC_2.26 strftime F
+GLIBC_2.26 strftime_l F
+GLIBC_2.26 wcsftime F
+GLIBC_2.26 wcsftime_l F
diff --git a/sysdeps/unix/sysv/linux/alpha/libc.abilist
b/sysdeps/unix/sysv/linux/alpha/libc.abilist
index ca657c2..4d86ff0 100644
--- a/sysdeps/unix/sysv/linux/alpha/libc.abilist
+++ b/sysdeps/unix/sysv/linux/alpha/libc.abilist
@@ -2010,8 +2010,14 @@ GLIBC_2.25 strfromf F
 GLIBC_2.25 strfroml F
 GLIBC_2.26 GLIBC_2.26 A
 GLIBC_2.26 __nl_langinfo_l F
+GLIBC_2.26 __strftime_l F
+GLIBC_2.26 __wcsftime_l F
 GLIBC_2.26 nl_langinfo F
 GLIBC_2.26 nl_langinfo_l F
+GLIBC_2.26 strftime F
+GLIBC_2.26 strftime_l F
+GLIBC_2.26 wcsftime F
+GLIBC_2.26 wcsftime_l F
 GLIBC_2.3 GLIBC_2.3 A
 GLIBC_2.3 __ctype_b_loc F
 GLIBC_2.3 __ctype_tolower_loc F
diff --git a/sysdeps/unix/sysv/linux/arm/libc.abilist
b/sysdeps/unix/sysv/linux/arm/libc.abilist
index 07876e0..7e82775 100644
--- a/sysdeps/unix/sysv/linux/arm/libc.abilist
+++ b/sysdeps/unix/sysv/linux/arm/libc.abilist
@@ -100,8 +100,14 @@ GLIBC_2.25 strfromf F
 GLIBC_2.25 strfroml F
 GLIBC_2.26 GLIBC_2.26 A
 GLIBC_2.26 __nl_langinfo_l F
+GLIBC_2.26 __strftime_l F
+GLIBC_2.26 __wcsftime_l F
 GLIBC_2.26 nl_langinfo F
 GLIBC_2.26 nl_langinfo_l F
+GLIBC_2.26 strftime F
+GLIBC_2.26 strftime_l F
+GLIBC_2.26 wcsftime F
+GLIBC_2.26 wcsftime_l F
 GLIBC_2.4 GLIBC_2.4 A
 GLIBC_2.4 _Exit F
 GLIBC_2.4 _IO_2_1_stderr_ D 0xa0
diff --git a/sysdeps/unix/sysv/linux/hppa/libc.abilist
b/sysdeps/unix/sysv/linux/hppa/libc.abilist
index c6d5e77..0aa1347 100644
--- a/sysdeps/unix/sysv/linux/hppa/libc.abilist
+++ b/sysdeps/unix/sysv/linux/hppa/libc.abilist
@@ -1864,8 +1864,14 @@ GLIBC_2.25 strfromf F
 GLIBC_2.25 strfroml F
 GLIBC_2.26 GLIBC_2.26 A
 GLIBC_2.26 __nl_langinfo_l F
+GLIBC_2.26 __strftime_l F
+GLIBC_2.26 __wcsftime_l F
 GLIBC_2.26 nl_langinfo F
 GLIBC_2.26 nl_langinfo_l F
+GLIBC_2.26 strftime F
+GLIBC_2.26 strftime_l F
+GLIBC_2.26 wcsftime F
+GLIBC_2.26 wcsftime_l F
 GLIBC_2.3 GLIBC_2.3 A
 GLIBC_2.3 __ctype_b_loc F
 GLIBC_2.3 __ctype_tolower_loc F
diff --git a/sysdeps/unix/sysv/linux/i386/libc.abilist
b/sysdeps/unix/sysv/linux/i386/libc.abilist
index e1dccbd..4c78241 100644
--- a/sysdeps/unix/sysv/linux/i386/libc.abilist
+++ b/sysdeps/unix/sysv/linux/i386/libc.abilist
@@ -2022,8 +2022,14 @@ GLIBC_2.25 strfromf F
 GLIBC_2.25 strfroml F
 GLIBC_2.26 GLIBC_2.26 A
 GLIBC_2.26 __nl_langinfo_l F
+GLIBC_2.26 __strftime_l F
+GLIBC_2.26 __wcsftime_l F
 GLIBC_2.26 nl_langinfo F
 GLIBC_2.26 nl_langinfo_l F
+GLIBC_2.26 strftime F
+GLIBC_2.26 strftime_l F
+GLIBC_2.26 wcsftime F
+GLIBC_2.26 wcsftime_l F
 GLIBC_2.3 GLIBC_2.3 A
 GLIBC_2.3 __ctype_b_loc F
 GLIBC_2.3 __ctype_tolower_loc F
diff --git a/sysdeps/unix/sysv/linux/ia64/libc.abilist
b/sysdeps/unix/sysv/linux/ia64/libc.abilist
index ce22307..13fd21b 100644
--- a/sysdeps/unix/sysv/linux/ia64/libc.abilist
+++ b/sysdeps/unix/sysv/linux/ia64/libc.abilist
@@ -1886,8 +1886,14 @@ GLIBC_2.25 strfromf F
 GLIBC_2.25 strfroml F
 GLIBC_2.26 GLIBC_2.26 A
 GLIBC_2.26 __nl_langinfo_l F
+GLIBC_2.26 __strftime_l F
+GLIBC_2.26 __wcsftime_l F
 GLIBC_2.26 nl_langinfo F
 GLIBC_2.26 nl_langinfo_l F
+GLIBC_2.26 strftime F
+GLIBC_2.26 strftime_l F
+GLIBC_2.26 wcsftime F
+GLIBC_2.26 wcsftime_l F
 GLIBC_2.3 GLIBC_2.3 A
 GLIBC_2.3 __ctype_b_loc F
 GLIBC_2.3 __ctype_tolower_loc F
diff --git a/sysdeps/unix/sysv/linux/m68k/coldfire/libc.abilist
b/sysdeps/unix/sysv/linux/m68k/coldfire/libc.abilist
index d0100f3..e6e3f94 100644
--- a/sysdeps/unix/sysv/linux/m68k/coldfire/libc.abilist
+++ b/sysdeps/unix/sysv/linux/m68k/coldfire/libc.abilist
@@ -101,8 +101,14 @@ GLIBC_2.25 strfromf F
 GLIBC_2.25 strfroml F
 GLIBC_2.26 GLIBC_2.26 A
 GLIBC_2.26 __nl_langinfo_l F
+GLIBC_2.26 __strftime_l F
+GLIBC_2.26 __wcsftime_l F
 GLIBC_2.26 nl_langinfo F
 GLIBC_2.26 nl_langinfo_l F
+GLIBC_2.26 strftime F
+GLIBC_2.26 strftime_l F
+GLIBC_2.26 wcsftime F
+GLIBC_2.26 wcsftime_l F
 GLIBC_2.4 GLIBC_2.4 A
 GLIBC_2.4 _Exit F
 GLIBC_2.4 _IO_2_1_stderr_ D 0x98
diff --git a/sysdeps/unix/sysv/linux/m68k/m680x0/libc.abilist
b/sysdeps/unix/sysv/linux/m68k/m680x0/libc.abilist
index 345f45a..712d4c0 100644
--- a/sysdeps/unix/sysv/linux/m68k/m680x0/libc.abilist
+++ b/sysdeps/unix/sysv/linux/m68k/m680x0/libc.abilist
@@ -1978,8 +1978,14 @@ GLIBC_2.25 strfromf F
 GLIBC_2.25 strfroml F
 GLIBC_2.26 GLIBC_2.26 A
 GLIBC_2.26 __nl_langinfo_l F
+GLIBC_2.26 __strftime_l F
+GLIBC_2.26 __wcsftime_l F
 GLIBC_2.26 nl_langinfo F
 GLIBC_2.26 nl_langinfo_l F
+GLIBC_2.26 strftime F
+GLIBC_2.26 strftime_l F
+GLIBC_2.26 wcsftime F
+GLIBC_2.26 wcsftime_l F
 GLIBC_2.3 GLIBC_2.3 A
 GLIBC_2.3 __ctype_b_loc F
 GLIBC_2.3 __ctype_tolower_loc F
diff --git a/sysdeps/unix/sysv/linux/microblaze/libc.abilist
b/sysdeps/unix/sysv/linux/microblaze/libc.abilist
index e878931..fcf24f1 100644
--- a/sysdeps/unix/sysv/linux/microblaze/libc.abilist
+++ b/sysdeps/unix/sysv/linux/microblaze/libc.abilist
@@ -2099,5 +2099,11 @@ GLIBC_2.25 strfromf F
 GLIBC_2.25 strfroml F
 GLIBC_2.26 GLIBC_2.26 A
 GLIBC_2.26 __nl_langinfo_l F
+GLIBC_2.26 __strftime_l F
+GLIBC_2.26 __wcsftime_l F
 GLIBC_2.26 nl_langinfo F
 GLIBC_2.26 nl_langinfo_l F
+GLIBC_2.26 strftime F
+GLIBC_2.26 strftime_l F
+GLIBC_2.26 wcsftime F
+GLIBC_2.26 wcsftime_l F
diff --git a/sysdeps/unix/sysv/linux/mips/mips32/fpu/libc.abilist
b/sysdeps/unix/sysv/linux/mips/mips32/fpu/libc.abilist
index d7ddfda..522f370 100644
--- a/sysdeps/unix/sysv/linux/mips/mips32/fpu/libc.abilist
+++ b/sysdeps/unix/sysv/linux/mips/mips32/fpu/libc.abilist
@@ -1953,8 +1953,14 @@ GLIBC_2.25 strfromf F
 GLIBC_2.25 strfroml F
 GLIBC_2.26 GLIBC_2.26 A
 GLIBC_2.26 __nl_langinfo_l F
+GLIBC_2.26 __strftime_l F
+GLIBC_2.26 __wcsftime_l F
 GLIBC_2.26 nl_langinfo F
 GLIBC_2.26 nl_langinfo_l F
+GLIBC_2.26 strftime F
+GLIBC_2.26 strftime_l F
+GLIBC_2.26 wcsftime F
+GLIBC_2.26 wcsftime_l F
 GLIBC_2.3 GLIBC_2.3 A
 GLIBC_2.3 __ctype_b_loc F
 GLIBC_2.3 __ctype_tolower_loc F
diff --git a/sysdeps/unix/sysv/linux/mips/mips32/nofpu/libc.abilist
b/sysdeps/unix/sysv/linux/mips/mips32/nofpu/libc.abilist
index 6c4a48e..a3b23f6 100644
--- a/sysdeps/unix/sysv/linux/mips/mips32/nofpu/libc.abilist
+++ b/sysdeps/unix/sysv/linux/mips/mips32/nofpu/libc.abilist
@@ -1951,8 +1951,14 @@ GLIBC_2.25 strfromf F
 GLIBC_2.25 strfroml F
 GLIBC_2.26 GLIBC_2.26 A
 GLIBC_2.26 __nl_langinfo_l F
+GLIBC_2.26 __strftime_l F
+GLIBC_2.26 __wcsftime_l F
 GLIBC_2.26 nl_langinfo F
 GLIBC_2.26 nl_langinfo_l F
+GLIBC_2.26 strftime F
+GLIBC_2.26 strftime_l F
+GLIBC_2.26 wcsftime F
+GLIBC_2.26 wcsftime_l F
 GLIBC_2.3 GLIBC_2.3 A
 GLIBC_2.3 __ctype_b_loc F
 GLIBC_2.3 __ctype_tolower_loc F
diff --git a/sysdeps/unix/sysv/linux/mips/mips64/n32/libc.abilist
b/sysdeps/unix/sysv/linux/mips/mips64/n32/libc.abilist
index c650742..b81c57d 100644
--- a/sysdeps/unix/sysv/linux/mips/mips64/n32/libc.abilist
+++ b/sysdeps/unix/sysv/linux/mips/mips64/n32/libc.abilist
@@ -1949,8 +1949,14 @@ GLIBC_2.25 strfromf F
 GLIBC_2.25 strfroml F
 GLIBC_2.26 GLIBC_2.26 A
 GLIBC_2.26 __nl_langinfo_l F
+GLIBC_2.26 __strftime_l F
+GLIBC_2.26 __wcsftime_l F
 GLIBC_2.26 nl_langinfo F
 GLIBC_2.26 nl_langinfo_l F
+GLIBC_2.26 strftime F
+GLIBC_2.26 strftime_l F
+GLIBC_2.26 wcsftime F
+GLIBC_2.26 wcsftime_l F
 GLIBC_2.3 GLIBC_2.3 A
 GLIBC_2.3 __ctype_b_loc F
 GLIBC_2.3 __ctype_tolower_loc F
diff --git a/sysdeps/unix/sysv/linux/mips/mips64/n64/libc.abilist
b/sysdeps/unix/sysv/linux/mips/mips64/n64/libc.abilist
index 4cce453..7b72781 100644
--- a/sysdeps/unix/sysv/linux/mips/mips64/n64/libc.abilist
+++ b/sysdeps/unix/sysv/linux/mips/mips64/n64/libc.abilist
@@ -1944,8 +1944,14 @@ GLIBC_2.25 strfromf F
 GLIBC_2.25 strfroml F
 GLIBC_2.26 GLIBC_2.26 A
 GLIBC_2.26 __nl_langinfo_l F
+GLIBC_2.26 __strftime_l F
+GLIBC_2.26 __wcsftime_l F
 GLIBC_2.26 nl_langinfo F
 GLIBC_2.26 nl_langinfo_l F
+GLIBC_2.26 strftime F
+GLIBC_2.26 strftime_l F
+GLIBC_2.26 wcsftime F
+GLIBC_2.26 wcsftime_l F
 GLIBC_2.3 GLIBC_2.3 A
 GLIBC_2.3 __ctype_b_loc F
 GLIBC_2.3 __ctype_tolower_loc F
diff --git a/sysdeps/unix/sysv/linux/nios2/libc.abilist
b/sysdeps/unix/sysv/linux/nios2/libc.abilist
index 971f21d..2339b12 100644
--- a/sysdeps/unix/sysv/linux/nios2/libc.abilist
+++ b/sysdeps/unix/sysv/linux/nios2/libc.abilist
@@ -2140,5 +2140,11 @@ GLIBC_2.25 strfromf F
 GLIBC_2.25 strfroml F
 GLIBC_2.26 GLIBC_2.26 A
 GLIBC_2.26 __nl_langinfo_l F
+GLIBC_2.26 __strftime_l F
+GLIBC_2.26 __wcsftime_l F
 GLIBC_2.26 nl_langinfo F
 GLIBC_2.26 nl_langinfo_l F
+GLIBC_2.26 strftime F
+GLIBC_2.26 strftime_l F
+GLIBC_2.26 wcsftime F
+GLIBC_2.26 wcsftime_l F
diff --git a/sysdeps/unix/sysv/linux/powerpc/powerpc32/fpu/libc.abilist
b/sysdeps/unix/sysv/linux/powerpc/powerpc32/fpu/libc.abilist
index d70a0c2..c60154e 100644
--- a/sysdeps/unix/sysv/linux/powerpc/powerpc32/fpu/libc.abilist
+++ b/sysdeps/unix/sysv/linux/powerpc/powerpc32/fpu/libc.abilist
@@ -1982,8 +1982,14 @@ GLIBC_2.25 strfromf F
 GLIBC_2.25 strfroml F
 GLIBC_2.26 GLIBC_2.26 A
 GLIBC_2.26 __nl_langinfo_l F
+GLIBC_2.26 __strftime_l F
+GLIBC_2.26 __wcsftime_l F
 GLIBC_2.26 nl_langinfo F
 GLIBC_2.26 nl_langinfo_l F
+GLIBC_2.26 strftime F
+GLIBC_2.26 strftime_l F
+GLIBC_2.26 wcsftime F
+GLIBC_2.26 wcsftime_l F
 GLIBC_2.3 GLIBC_2.3 A
 GLIBC_2.3 __ctype_b_loc F
 GLIBC_2.3 __ctype_tolower_loc F
diff --git a/sysdeps/unix/sysv/linux/powerpc/powerpc32/nofpu/libc.abilist
b/sysdeps/unix/sysv/linux/powerpc/powerpc32/nofpu/libc.abilist
index 71e39ae..db2f188 100644
--- a/sysdeps/unix/sysv/linux/powerpc/powerpc32/nofpu/libc.abilist
+++ b/sysdeps/unix/sysv/linux/powerpc/powerpc32/nofpu/libc.abilist
@@ -1987,8 +1987,14 @@ GLIBC_2.25 strfromf F
 GLIBC_2.25 strfroml F
 GLIBC_2.26 GLIBC_2.26 A
 GLIBC_2.26 __nl_langinfo_l F
+GLIBC_2.26 __strftime_l F
+GLIBC_2.26 __wcsftime_l F
 GLIBC_2.26 nl_langinfo F
 GLIBC_2.26 nl_langinfo_l F
+GLIBC_2.26 strftime F
+GLIBC_2.26 strftime_l F
+GLIBC_2.26 wcsftime F
+GLIBC_2.26 wcsftime_l F
 GLIBC_2.3 GLIBC_2.3 A
 GLIBC_2.3 __ctype_b_loc F
 GLIBC_2.3 __ctype_tolower_loc F
diff --git a/sysdeps/unix/sysv/linux/powerpc/powerpc64/libc-le.abilist
b/sysdeps/unix/sysv/linux/powerpc/powerpc64/libc-le.abilist
index b14cd42..2d4296b 100644
--- a/sysdeps/unix/sysv/linux/powerpc/powerpc64/libc-le.abilist
+++ b/sysdeps/unix/sysv/linux/powerpc/powerpc64/libc-le.abilist
@@ -2187,5 +2187,11 @@ GLIBC_2.25 strfromf F
 GLIBC_2.25 strfroml F
 GLIBC_2.26 GLIBC_2.26 A
 GLIBC_2.26 __nl_langinfo_l F
+GLIBC_2.26 __strftime_l F
+GLIBC_2.26 __wcsftime_l F
 GLIBC_2.26 nl_langinfo F
 GLIBC_2.26 nl_langinfo_l F
+GLIBC_2.26 strftime F
+GLIBC_2.26 strftime_l F
+GLIBC_2.26 wcsftime F
+GLIBC_2.26 wcsftime_l F
diff --git a/sysdeps/unix/sysv/linux/powerpc/powerpc64/libc.abilist
b/sysdeps/unix/sysv/linux/powerpc/powerpc64/libc.abilist
index 947db2d..956fe1b 100644
--- a/sysdeps/unix/sysv/linux/powerpc/powerpc64/libc.abilist
+++ b/sysdeps/unix/sysv/linux/powerpc/powerpc64/libc.abilist
@@ -101,8 +101,14 @@ GLIBC_2.25 strfromf F
 GLIBC_2.25 strfroml F
 GLIBC_2.26 GLIBC_2.26 A
 GLIBC_2.26 __nl_langinfo_l F
+GLIBC_2.26 __strftime_l F
+GLIBC_2.26 __wcsftime_l F
 GLIBC_2.26 nl_langinfo F
 GLIBC_2.26 nl_langinfo_l F
+GLIBC_2.26 strftime F
+GLIBC_2.26 strftime_l F
+GLIBC_2.26 wcsftime F
+GLIBC_2.26 wcsftime_l F
 GLIBC_2.3 GLIBC_2.3 A
 GLIBC_2.3 _Exit F
 GLIBC_2.3 _IO_2_1_stderr_ D 0xe0
diff --git a/sysdeps/unix/sysv/linux/s390/s390-32/libc.abilist
b/sysdeps/unix/sysv/linux/s390/s390-32/libc.abilist
index ec98511..1ca9d5d 100644
--- a/sysdeps/unix/sysv/linux/s390/s390-32/libc.abilist
+++ b/sysdeps/unix/sysv/linux/s390/s390-32/libc.abilist
@@ -1982,8 +1982,14 @@ GLIBC_2.25 strfromf F
 GLIBC_2.25 strfroml F
 GLIBC_2.26 GLIBC_2.26 A
 GLIBC_2.26 __nl_langinfo_l F
+GLIBC_2.26 __strftime_l F
+GLIBC_2.26 __wcsftime_l F
 GLIBC_2.26 nl_langinfo F
 GLIBC_2.26 nl_langinfo_l F
+GLIBC_2.26 strftime F
+GLIBC_2.26 strftime_l F
+GLIBC_2.26 wcsftime F
+GLIBC_2.26 wcsftime_l F
 GLIBC_2.3 GLIBC_2.3 A
 GLIBC_2.3 __ctype_b_loc F
 GLIBC_2.3 __ctype_tolower_loc F
diff --git a/sysdeps/unix/sysv/linux/s390/s390-64/libc.abilist
b/sysdeps/unix/sysv/linux/s390/s390-64/libc.abilist
index 0c1832c..f17ed10 100644
--- a/sysdeps/unix/sysv/linux/s390/s390-64/libc.abilist
+++ b/sysdeps/unix/sysv/linux/s390/s390-64/libc.abilist
@@ -1883,8 +1883,14 @@ GLIBC_2.25 strfromf F
 GLIBC_2.25 strfroml F
 GLIBC_2.26 GLIBC_2.26 A
 GLIBC_2.26 __nl_langinfo_l F
+GLIBC_2.26 __strftime_l F
+GLIBC_2.26 __wcsftime_l F
 GLIBC_2.26 nl_langinfo F
 GLIBC_2.26 nl_langinfo_l F
+GLIBC_2.26 strftime F
+GLIBC_2.26 strftime_l F
+GLIBC_2.26 wcsftime F
+GLIBC_2.26 wcsftime_l F
 GLIBC_2.3 GLIBC_2.3 A
 GLIBC_2.3 __ctype_b_loc F
 GLIBC_2.3 __ctype_tolower_loc F
diff --git a/sysdeps/unix/sysv/linux/sh/libc.abilist
b/sysdeps/unix/sysv/linux/sh/libc.abilist
index b7d389c..5805beb 100644
--- a/sysdeps/unix/sysv/linux/sh/libc.abilist
+++ b/sysdeps/unix/sysv/linux/sh/libc.abilist
@@ -1868,8 +1868,14 @@ GLIBC_2.25 strfromf F
 GLIBC_2.25 strfroml F
 GLIBC_2.26 GLIBC_2.26 A
 GLIBC_2.26 __nl_langinfo_l F
+GLIBC_2.26 __strftime_l F
+GLIBC_2.26 __wcsftime_l F
 GLIBC_2.26 nl_langinfo F
 GLIBC_2.26 nl_langinfo_l F
+GLIBC_2.26 strftime F
+GLIBC_2.26 strftime_l F
+GLIBC_2.26 wcsftime F
+GLIBC_2.26 wcsftime_l F
 GLIBC_2.3 GLIBC_2.3 A
 GLIBC_2.3 __ctype_b_loc F
 GLIBC_2.3 __ctype_tolower_loc F
diff --git a/sysdeps/unix/sysv/linux/sparc/sparc32/libc.abilist
b/sysdeps/unix/sysv/linux/sparc/sparc32/libc.abilist
index ec25445..3aefd37 100644
--- a/sysdeps/unix/sysv/linux/sparc/sparc32/libc.abilist
+++ b/sysdeps/unix/sysv/linux/sparc/sparc32/libc.abilist
@@ -1974,8 +1974,14 @@ GLIBC_2.25 strfromf F
 GLIBC_2.25 strfroml F
 GLIBC_2.26 GLIBC_2.26 A
 GLIBC_2.26 __nl_langinfo_l F
+GLIBC_2.26 __strftime_l F
+GLIBC_2.26 __wcsftime_l F
 GLIBC_2.26 nl_langinfo F
 GLIBC_2.26 nl_langinfo_l F
+GLIBC_2.26 strftime F
+GLIBC_2.26 strftime_l F
+GLIBC_2.26 wcsftime F
+GLIBC_2.26 wcsftime_l F
 GLIBC_2.3 GLIBC_2.3 A
 GLIBC_2.3 __ctype_b_loc F
 GLIBC_2.3 __ctype_tolower_loc F
diff --git a/sysdeps/unix/sysv/linux/sparc/sparc64/libc.abilist
b/sysdeps/unix/sysv/linux/sparc/sparc64/libc.abilist
index 7fdb080..d1b67c6 100644
--- a/sysdeps/unix/sysv/linux/sparc/sparc64/libc.abilist
+++ b/sysdeps/unix/sysv/linux/sparc/sparc64/libc.abilist
@@ -1912,8 +1912,14 @@ GLIBC_2.25 strfromf F
 GLIBC_2.25 strfroml F
 GLIBC_2.26 GLIBC_2.26 A
 GLIBC_2.26 __nl_langinfo_l F
+GLIBC_2.26 __strftime_l F
+GLIBC_2.26 __wcsftime_l F
 GLIBC_2.26 nl_langinfo F
 GLIBC_2.26 nl_langinfo_l F
+GLIBC_2.26 strftime F
+GLIBC_2.26 strftime_l F
+GLIBC_2.26 wcsftime F
+GLIBC_2.26 wcsftime_l F
 GLIBC_2.3 GLIBC_2.3 A
 GLIBC_2.3 __ctype_b_loc F
 GLIBC_2.3 __ctype_tolower_loc F
diff --git a/sysdeps/unix/sysv/linux/tile/tilegx/tilegx32/libc.abilist
b/sysdeps/unix/sysv/linux/tile/tilegx/tilegx32/libc.abilist
index 3fb7f02..2d0d224 100644
--- a/sysdeps/unix/sysv/linux/tile/tilegx/tilegx32/libc.abilist
+++ b/sysdeps/unix/sysv/linux/tile/tilegx/tilegx32/libc.abilist
@@ -2106,5 +2106,11 @@ GLIBC_2.25 strfromf F
 GLIBC_2.25 strfroml F
 GLIBC_2.26 GLIBC_2.26 A
 GLIBC_2.26 __nl_langinfo_l F
+GLIBC_2.26 __strftime_l F
+GLIBC_2.26 __wcsftime_l F
 GLIBC_2.26 nl_langinfo F
 GLIBC_2.26 nl_langinfo_l F
+GLIBC_2.26 strftime F
+GLIBC_2.26 strftime_l F
+GLIBC_2.26 wcsftime F
+GLIBC_2.26 wcsftime_l F
diff --git a/sysdeps/unix/sysv/linux/tile/tilegx/tilegx64/libc.abilist
b/sysdeps/unix/sysv/linux/tile/tilegx/tilegx64/libc.abilist
index 02dfc7e..3278905 100644
--- a/sysdeps/unix/sysv/linux/tile/tilegx/tilegx64/libc.abilist
+++ b/sysdeps/unix/sysv/linux/tile/tilegx/tilegx64/libc.abilist
@@ -2106,5 +2106,11 @@ GLIBC_2.25 strfromf F
 GLIBC_2.25 strfroml F
 GLIBC_2.26 GLIBC_2.26 A
 GLIBC_2.26 __nl_langinfo_l F
+GLIBC_2.26 __strftime_l F
+GLIBC_2.26 __wcsftime_l F
 GLIBC_2.26 nl_langinfo F
 GLIBC_2.26 nl_langinfo_l F
+GLIBC_2.26 strftime F
+GLIBC_2.26 strftime_l F
+GLIBC_2.26 wcsftime F
+GLIBC_2.26 wcsftime_l F
diff --git a/sysdeps/unix/sysv/linux/tile/tilepro/libc.abilist
b/sysdeps/unix/sysv/linux/tile/tilepro/libc.abilist
index 3fb7f02..2d0d224 100644
--- a/sysdeps/unix/sysv/linux/tile/tilepro/libc.abilist
+++ b/sysdeps/unix/sysv/linux/tile/tilepro/libc.abilist
@@ -2106,5 +2106,11 @@ GLIBC_2.25 strfromf F
 GLIBC_2.25 strfroml F
 GLIBC_2.26 GLIBC_2.26 A
 GLIBC_2.26 __nl_langinfo_l F
+GLIBC_2.26 __strftime_l F
+GLIBC_2.26 __wcsftime_l F
 GLIBC_2.26 nl_langinfo F
 GLIBC_2.26 nl_langinfo_l F
+GLIBC_2.26 strftime F
+GLIBC_2.26 strftime_l F
+GLIBC_2.26 wcsftime F
+GLIBC_2.26 wcsftime_l F
diff --git a/sysdeps/unix/sysv/linux/x86_64/64/libc.abilist
b/sysdeps/unix/sysv/linux/x86_64/64/libc.abilist
index a495ad6..d1baae9 100644
--- a/sysdeps/unix/sysv/linux/x86_64/64/libc.abilist
+++ b/sysdeps/unix/sysv/linux/x86_64/64/libc.abilist
@@ -1863,8 +1863,14 @@ GLIBC_2.25 strfromf F
 GLIBC_2.25 strfroml F
 GLIBC_2.26 GLIBC_2.26 A
 GLIBC_2.26 __nl_langinfo_l F
+GLIBC_2.26 __strftime_l F
+GLIBC_2.26 __wcsftime_l F
 GLIBC_2.26 nl_langinfo F
 GLIBC_2.26 nl_langinfo_l F
+GLIBC_2.26 strftime F
+GLIBC_2.26 strftime_l F
+GLIBC_2.26 wcsftime F
+GLIBC_2.26 wcsftime_l F
 GLIBC_2.3 GLIBC_2.3 A
 GLIBC_2.3 __ctype_b_loc F
 GLIBC_2.3 __ctype_tolower_loc F
diff --git a/sysdeps/unix/sysv/linux/x86_64/x32/libc.abilist
b/sysdeps/unix/sysv/linux/x86_64/x32/libc.abilist
index e47b983..0e69967 100644
--- a/sysdeps/unix/sysv/linux/x86_64/x32/libc.abilist
+++ b/sysdeps/unix/sysv/linux/x86_64/x32/libc.abilist
@@ -2106,5 +2106,11 @@ GLIBC_2.25 strfromf F
 GLIBC_2.25 strfroml F
 GLIBC_2.26 GLIBC_2.26 A
 GLIBC_2.26 __nl_langinfo_l F
+GLIBC_2.26 __strftime_l F
+GLIBC_2.26 __wcsftime_l F
 GLIBC_2.26 nl_langinfo F
 GLIBC_2.26 nl_langinfo_l F
+GLIBC_2.26 strftime F
+GLIBC_2.26 strftime_l F
+GLIBC_2.26 wcsftime F
+GLIBC_2.26 wcsftime_l F